package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ImageDownLog;
import com.izouma.awesomeadmin.service.ImageDownLogService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/imageDownLog")
@RequiresAuthentication
public class ImageDownLogController {

    @Autowired
    private ImageDownLogService imageDownLogService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ImageDownLog record) {
        List<ImageDownLog> pp = imageDownLogService.getImageDownLogList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getImageDownLog", method = RequestMethod.GET)
    @ResponseBody
    public Result getImageDownLog(@RequestParam(required = false, value = "id") String id) {
        ImageDownLog data = imageDownLogService.getImageDownLogById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ImageDownLog record) {
        ImageDownLog data = imageDownLogService.getImageDownLog(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ImageDownLog record) {
        Map<String, Object> result = new HashMap<>();

        List<ImageDownLog> pp =imageDownLogService.getImageDownLogByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ImageDownLog record) {
        boolean num = imageDownLogService.createImageDownLog(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateImageDownLog(ImageDownLog record) {
        boolean num = imageDownLogService.updateImageDownLog(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteImageDownLog(ImageDownLog record) {

        boolean num = imageDownLogService.deleteImageDownLog(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ImageDownLog record) throws Exception {

    List<ImageDownLog> imageDownLogs = imageDownLogService.getImageDownLogList(record);


        String sheetName = "image_down_log";
        String titleName = "图片下载日志数据表";
        String fileName = "图片下载日志表";
        int columnNumber = 14;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "订单" ,   "类型" ,   "图片名" ,   "状态" ,   "大小" ,   "下载编号" ,   "总数量" ,   "当前数量"  };
        String[][] dataList = new String[imageDownLogs.size()][14];

        for (int i = 0; i < imageDownLogs.size(); i++) {

                        dataList[i][0] = String.valueOf(imageDownLogs.get(i).getId());
                        dataList[i][1] = String.valueOf(imageDownLogs.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(imageDownLogs.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(imageDownLogs.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(imageDownLogs.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(imageDownLogs.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(imageDownLogs.get(i).getOrderId());
                        dataList[i][7] = String.valueOf(imageDownLogs.get(i).getTypeFlag());
                        dataList[i][8] = String.valueOf(imageDownLogs.get(i).getImageName());
                        dataList[i][9] = String.valueOf(imageDownLogs.get(i).getStatusFlag());
                        dataList[i][10] = String.valueOf(imageDownLogs.get(i).getImageSize());
                        dataList[i][11] = String.valueOf(imageDownLogs.get(i).getImageCode());
                        dataList[i][12] = String.valueOf(imageDownLogs.get(i).getTotalNum());
                        dataList[i][13] = String.valueOf(imageDownLogs.get(i).getNowNum());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

